'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var noop = function noop() {};

/**
 * 
 * @param {Function} customHandler 
 * @returns 
 */
var setPromiseUnCatchHandler = exports.setPromiseUnCatchHandler = function setPromiseUnCatchHandler() {
    var customHandler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;

    var type = typeof customHandler === 'undefined' ? 'undefined' : _typeof(customHandler);
    if (type !== 'function') {
        console.log('setPromiseUnCatchHandler should be callback function, but params is + ', type);
        console.log('Not setting the Promise handler .. please fix setPromiseUnCatchHandler call');
        return;
    }
    require('promise/setimmediate/rejection-tracking').enable({
        allRejections: true,
        onUnhandled: customHandler,
        onHandled: function onHandled(id) {
            var warning = 'Promise Rejection Handled (id: ' + id + ')\n' + 'This means you can ignore any previous messages of the form ' + ('"Possible Unhandled Promise Rejection (id: ' + id + '):"');
            console.warn(warning);
        }
    });
};